/*

##########################################
#                                        #
#   FRET_Analyzer plug-in Informations   #
#                                        #
##########################################


	Version 1.0 - 2006

	Developped for ESBS, Illkich France in 2005

		Programer   : 	Olivier Marchal 	marchal_olivier at hotmail.fr

		Concept     : 	Noel Converset		noel_converset at hotmail.com


	Inspiration  : 	Colocalization finder plugin by C. Laummonerie & J. Mutterer
			Color Comparison plugin by Bill O'Connell


	For further information please visit  
	http://recepteurs.u-strasbg.fr/upr9050_PHP/equipes/JLG/fret.php
	or contact us...




****************************************************************/


import java.awt.*;
import java.text.*;
import ij.*;
import ij.process.*;
import ij.gui.*;
import ij.plugin.filter.PlugInFilter;
import ij.process.ImageConverter;
import ij.text.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.Properties;
import java.io.*;
import ij.Prefs;
import javax.swing.border.*;
import ij.plugin.*;
import ij.measure.*;
import ij.util.*;
import ij.plugin.filter.PlugInFilter;
import ij.io.*;
import java.lang.*;
import java.util.*;
import java.awt.image.*;
import ij.process.ImageConverter.*;
import ij.process.ImageProcessor.*;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JMenuBar;
import javax.swing.JMenu;
import javax.swing.JMenuItem;
import javax.swing.JLabel;
import javax.swing.border.Border;
import java.lang.String;
import java.awt.Dialog;
import java.lang.Error;
import ij.WindowManager;
import ij.plugin.Macro_Runner;
import java.net.URL;



/****************************************************************
****************************************************************
*
*	classe Fret analyzer
*
*****************************************************************
****************************************************************/


public class Fret_Analyzer implements PlugInFilter, MouseListener {


  int[] wList;
  private String[] titles;
  double []tab_coeff1= new double[10];
  double []tab_coeff2= new double[10];
  private JFrame controllingFrame; //needed for dialogs


  private ImagePlus imp;



  public int setup(String args, ImagePlus imp)
  {
    if (args.equals("about")){
IJ.showMessage("Fret_Analyzer plugin",
 "By Olivier Marchal & Noel Converset\n"
 +"\n"
 +"Developped at ESBS\n"
 +"Illkich France\n"
 +"\n"
 +"Contacts :\n"
 +"marchal_olivier at hotmail.fr\n"
 +"noel_converset at hotmail.com\n"
 );

return DONE;
}

         return DOES_8G+DOES_8C+NO_CHANGES;
  }

  public void run(ImageProcessor ip) {



    /* GenericDialog gd = new GenericDialog("Security");

      gd.addMessage("Enter your security code");
      gd.addStringField("code :","");
        gd.showDialog();

        if(gd.wasCanceled()){
          IJ.error("Canceled");
          return;
        }

      result=gd.getNextString();

        if(result.compareTo("ordimagerie")!=0) { IJ.showMessage("Wrong code"); return;}

	*/

	/*
  	  Frame f1 = new Frame("Security");
    	 String message = "Enter your security code";
     	String text = JOptionPane.showInputDialog(f1, message,"Security",1);
       	  if (text == null) {
             	// User clicked cancel
             	return;
     		}
      	  if(text.compareTo("ordimagerie")!=0) {
        	IJ.showMessage("Wrong code");
        	return;
      		}
	*/

    	 // else{

    		wList = WindowManager.getIDList();
          	if (wList==null || wList.length<2) {
              		IJ.showMessage("Error", "There must two windows open");
              		return;
          		}

          	titles = new String[wList.length];
          	for (int i=0; i<wList.length; i++) {
              		ImagePlus imp = WindowManager.getImage(wList[i]);
              		if (imp!=null)
                  		titles[i] = imp.getTitle();
              		else
                  		titles[i] = "";
      			}



  		 Frame_fret olive1 = new Frame_fret(titles,wList);
   		olive1.show();

		// }


  	}


     public void mousePressed(MouseEvent e) {}
     public void mouseExited(MouseEvent e)  {}
     public void mouseClicked(MouseEvent e) {}
     public void mouseEntered(MouseEvent e) {}
     public void mouseReleased(MouseEvent e){}


}



/****************************************************************
****************************************************************
*
*	classe interface et color comparaison
*
*****************************************************************
****************************************************************/


 class Frame_fret extends JFrame  {

String[] titles;
int[] wList;

double alpha = 0.05;
int index1=0;
int index2=0;
int index3=0;
int POLAR = 0, PERCENTAGE = 1, REGRESSION = 2;
static double EPSILON = 0.00001;
double lo, hi; // hue limits in radians
double off120, off240;
double[] hist = null;
int threshold=0;
double scaleIntensity = 1.0/ Math.sqrt(2.0);
double PI2 = Math.PI / 2.0;
double scaleHue;
double sumIntent = 0;
double binsize;
byte[] pixels1, pixels2, pixels11, pixels22;
int runCount = 0;
double[] xc = new double[256];
 int loDegree=260;
boolean weightHistogram=true;
boolean titleInImage=true;
boolean showPalette=false;
boolean regressionGraph=false;
boolean single=false;
int mode=2;
int iswitch=0;
double thresholdPercent=1.0;
 int hiDegree=-25;
int nbins=25;
int compt=0;
int compt2=0;
double tmp[] = new double [10];



Compar s;
Coloc col;
Bg background;
double []tab_coeff1= new double[10];
double []tab_coeff2= new double[10];
int i,counter,i1Index,i2Index,i3Index,i4Index;
ImagePlus i1,i2,i3,i4,imResu,imgray,im_fret, im_corr_mu, im_corr_min,im_corr_max;
ImagePlus imp1, imp2, colImage;
ImageProcessor ip1, ip2, ip4,ipPolar,ip;
boolean check4=false;

String[] model={"Noel","Youvan","Gordon","Xia","Acceptor alone"};
ImageCanvas canvas;



  JPanel contentPane;
  BorderLayout borderLayout1 = new BorderLayout();
  JMenuBar jMenuBar1 = new JMenuBar();
  JMenu jMenuFile = new JMenu();
  JMenuItem jMenuFileRefresh = new JMenuItem();
  JMenuItem jMenuFileExit = new JMenuItem();
  JMenu jMenuReset = new JMenu();
  JMenuItem jMenuResetReset1 = new JMenuItem();
  JMenuItem jMenuResetReset2 = new JMenuItem();
  JMenu jMenuHelp = new JMenu();
  JMenuItem jMenuHelpAbout = new JMenuItem();
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel jPanel1 = new JPanel();
  JPanel jPanel2 = new JPanel();

  Border border1 = BorderFactory.createLineBorder(Color.black, 2);

  JComboBox jComboBox1 = new JComboBox();
      JComboBox jComboBox2 = new JComboBox();
      JComboBox jComboBox3 = new JComboBox();
      JComboBox jComboBox4 = new JComboBox();
      JComboBox jComboBox5 = new JComboBox();
      JComboBox jComboBox6 = new JComboBox();
      JComboBox jComboBox7 = new JComboBox();
   JLabel jLabel1 = new JLabel();
      JLabel jLabel2 = new JLabel();
      JLabel jLabel3 = new JLabel();
      JLabel jLabel4 = new JLabel();
      JLabel jLabel5 = new JLabel();
      JLabel jLabel6 = new JLabel();
      JLabel jLabel7 = new JLabel();
      JLabel jLabel8 = new JLabel();
      JLabel jLabel9 = new JLabel();
      JLabel jLabel10 = new JLabel();
      JLabel jLabel11 = new JLabel();

   JButton jButton1 = new JButton();
      JButton jButton2 = new JButton();
      JButton jButton3 = new JButton();
   JTextField jTextField3 = new JTextField();
      JTextField jTextField4 = new JTextField();
   JCheckBox jCheckBox1 = new JCheckBox();
      JCheckBox jCheckBox2 = new JCheckBox();
      JCheckBox jCheckBox3 = new JCheckBox();
   JLabel jLabel13 = new JLabel();
   JLabel jLabel14 = new JLabel();
   JLabel jLabel15 = new JLabel();
   JLabel jLabel16 = new JLabel();
   JLabel jLabel17 = new JLabel();
   JLabel jLabel18 = new JLabel();
   JLabel jLabel19 = new JLabel();
   JLabel jLabel20 = new JLabel();
   JLabel jLabel21 = new JLabel();
   JLabel jLabel22 = new JLabel();
   JLabel jLabel23 = new JLabel();
   JLabel jLabel24 = new JLabel();
   JLabel jLabel25 = new JLabel();
   JLabel jLabel26 = new JLabel();
   JLabel jLabel27 = new JLabel();
   JLabel jLabel28 = new JLabel();
   JLabel jLabel29 = new JLabel();
   JLabel jLabel30 = new JLabel();
   JTextField jTextField1 = new JTextField();
   JTextField jTextField2 = new JTextField();
   JCheckBox jCheckBox4 = new JCheckBox();
   JLabel jLabel31 = new JLabel();
   JLabel jLabel32 = new JLabel();
   JButton jButton4 = new JButton();
   JButton jButton5 = new JButton();
   JTextField jTextField5 = new JTextField();
   JTextField jTextField6 = new JTextField();
   JComboBox jComboBox8 = new JComboBox();
   JLabel jLabel34 = new JLabel();
   JButton jButton6 = new JButton();
   JTextField jTextField7 = new JTextField();
  JLabel jLabel12 = new JLabel();
  JLabel jLabel33 = new JLabel();
  JLabel jLabel35 = new JLabel();
  JLabel jLabel36 = new JLabel();
  JLabel jLabel37 = new JLabel();
  JLabel jLabel38 = new JLabel();

 // GridBagLayout gridBagLayout1 = new GridBagLayout();
 //  GridBagLayout gridBagLayout2 = new GridBagLayout();
 // GridBagLayout gridBagLayout3 = new GridBagLayout();


  public Frame_fret() {
    try {
      jbInit();
    }
    catch (Exception exception) {
      exception.printStackTrace();
    }
  }


  public Frame_fret(String[] titles, int[] wList) {
   this.titles = titles;
   this.wList=wList;

    try {
    jbInit();

  }
  catch (Exception exception) {
    exception.printStackTrace();
  }
}



  private void jbInit() throws Exception {

    int taille[] = new int[wList.length];
    int taille_tmp[] = new int[wList.length];
    int taille_x = 0;
    int i = 0;

    for (i = 0; i < wList.length; i++) {
      taille[i] = 0;
      taille_tmp[i] = 0;
    }

    for (i = 0; i < wList.length; i++) taille[i] = titles[i].length();

    for (i = 0; i < wList.length; i++) taille_tmp[i] = taille[i];
    sort_array(taille_tmp, wList.length);

  // 7 pixels par char
    int cpt = 0;
    for (i = 0; i < wList.length; i++) {
      if (taille[i] > 23) cpt++;

    }

    if (cpt >= 1) {

      for (i = 0; i < wList.length; i++)
        if (taille_tmp[wList.length - 1] == taille[i]) taille_x = 430 +
            7 * (taille[i] - 23);

    }

    else taille_x = 430;

    contentPane = (JPanel) getContentPane();
   // contentPane.setLayout(borderLayout1);
    setSize(new Dimension(taille_x, 550));
    setTitle("FRET and Colocalization Analyzer");

    jTabbedPane1.setBounds(new Rectangle(0, 0, 430, 480));
    jPanel1.setLayout(null);
    jPanel2.setLayout(null);
   // contentPane.setLayout(gridBagLayout1);

     //jPanel1.setLayout(gridBagLayout2);
    //  jPanel2.setLayout(gridBagLayout3);

    jMenuFile.setText("File");
    jMenuFileExit.setText("Exit");
    jMenuReset.setText("Reset");
    jMenuResetReset1.setText("Reset Donor");
    jMenuResetReset2.setText("Reset Acceptor");
    jMenuFileRefresh.setText("Refresh files list");


    jMenuFileRefresh.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuFileRefresh_actionPerformed(e);
      }
    });

    jMenuResetReset1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuResetReset1_actionPerformed(e);
      }
    });

    jMenuResetReset2.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuResetReset2_actionPerformed(e);
      }
    });

    jMenuFileExit.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuFileExit_actionPerformed(e);
      }
    });

    jMenuHelp.setText("Help");
    jMenuHelpAbout.setText("About this plugin");

    jMenuHelpAbout.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        jMenuHelpAbout_actionPerformed(e);
      }
    });

    jTabbedPane1.addFocusListener(new FocusAdapter() {
      public void focusGained(FocusEvent e) {
        jTabbedPane1_focusGained(e);
      }
    });


    jComboBox1.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //donor 1
     jComboBox1.setBounds(new Rectangle(170, 83, 230, 23));
    jComboBox1.setBackground(Color.white);
    for(i=0;i<wList.length;i++) jComboBox1.addItem(makeObj(titles[i]));

    jComboBox2.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //acceptor1
      jComboBox2.setBounds(new Rectangle(170, 294, 230, 23));
    for(i=0;i<wList.length;i++) jComboBox2.addItem(makeObj(titles[i]));
      jComboBox2.setBackground(Color.white);

      jComboBox3.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //acceptor2
      jComboBox3.setBounds(new Rectangle(170, 320, 230, 23));
       jComboBox3.setBackground(Color.white);
     for(i=0;i<wList.length;i++) jComboBox3.addItem(makeObj(titles[i]));

     jComboBox4.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //donor 2
     jComboBox4.setBounds(new Rectangle(170, 110, 230, 23));
      jComboBox4.setBackground(Color.white);
     for(i=0;i<wList.length;i++) jComboBox4.addItem(makeObj(titles[i]));

     jComboBox5.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //fret 1
     jComboBox5.setBounds(new Rectangle(167, 55, 230, 23));
      jComboBox5.setBackground(Color.white);
     for(i=0;i<wList.length;i++) jComboBox5.addItem(makeObj(titles[i]));

     jComboBox6.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //fret 2
     jComboBox6.setBounds(new Rectangle(167, 81, 230, 23));
      jComboBox6.setBackground(Color.white);
     for(i=0;i<wList.length;i++) jComboBox6.addItem(makeObj(titles[i]));

     jComboBox7.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12)); //fret 3
     jComboBox7.setBounds(new Rectangle(167, 107, 230, 23));
      jComboBox7.setBackground(Color.white);
     for(i=0;i<wList.length;i++) jComboBox7.addItem(makeObj(titles[i]));
     for(i=0;i<model.length;i++) {}

     jLabel1.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel1.setText("Acceptor channel image");
        jLabel1.setBounds(new Rectangle(12, 297, 140, 15));
         jLabel2.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel2.setText("FRET channel image");
        jLabel2.setBounds(new Rectangle(12, 113, 140, 15));
        jLabel3.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel3.setText("FRET channel image");
        jLabel3.setBounds(new Rectangle(12, 323, 140, 15));

         jLabel4.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel4.setText("Donor channel image");
        jLabel4.setBounds(new Rectangle(12, 87, 140, 15));
        jLabel5.setBackground(Color.lightGray);
        jLabel5.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
        jLabel5.setText("Donor BT evaluation");
        jLabel5.setBounds(new Rectangle(12, 23, 140, 15));
        jLabel6.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
        jLabel6.setText("Acceptor BT evaluation");

          jLabel6.setBounds(new Rectangle(12, 233, 140, 15));
     jLabel8.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel8.setText("Acceptor channel image");
        jLabel8.setBounds(new Rectangle(11, 86, 140, 15));
        jLabel9.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel9.setText("FRET channel image");
          jLabel9.setBounds(new Rectangle(12, 111, 140, 15));
     jLabel10.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel10.setText("Results");
        jLabel10.setBounds(new Rectangle(58, 183, 54, 15));
        jLabel11.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jLabel11.setText("Results");
        jLabel11.setBounds(new Rectangle(58, 393, 60, 15));


        jButton1.setBounds(new Rectangle(300, 143, 100, 23));
        jButton1.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jButton1.setText("Get");
        jButton1.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jButton1_actionPerformed(e);
          }
        });

          jButton2.setBounds(new Rectangle(300, 353, 100, 23));
        jButton2.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jButton2.setText("Get");
        jButton2.addActionListener(new ActionListener() {
          public void actionPerformed(ActionEvent e) {
            jButton2_actionPerformed(e);
          }
        });
         jButton3.setBounds(new Rectangle(261, 406, 100, 23));
         jButton3.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
       jButton3.setText("FRET index");
       jButton3.addActionListener(new ActionListener() {
         public void actionPerformed(ActionEvent e) {
           jButton3_actionPerformed(e);
         }
       });

       jCheckBox1.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
       jCheckBox1.setText("Colocalization and FRET");
         jCheckBox1.setSelected(true);
         jCheckBox1.setBounds(new Rectangle(12, 369, 178, 23));

     jCheckBox2.setSelected(true);
       jCheckBox2.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
       jCheckBox2.setText("Show controls");
       jCheckBox2.setBounds(new Rectangle(58, 143, 120, 23));

       jCheckBox3.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
       jCheckBox3.setText("Show controls");
         jCheckBox3.setSelected(true);
       jCheckBox3.setBounds(new Rectangle(58, 353, 117, 23));

       jTextField3.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jTextField3.setText("1");
         jTextField3.setHorizontalAlignment(SwingConstants.CENTER);
         jTextField3.setBounds(new Rectangle(170, 59, 50, 21));

         jTextField4.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
        jTextField4.setText("1");
         jTextField4.setHorizontalAlignment(SwingConstants.CENTER);
         jTextField4.setBounds(new Rectangle(170, 269, 50, 21));

         jLabel13.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel13.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel13.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel13.setText("mean");
         jLabel13.setBounds(new Rectangle(127, 174, 43, 17));
         jLabel14.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel14.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel14.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel14.setText("min");
         jLabel14.setBounds(new Rectangle(190, 174, 43, 17));
         jLabel15.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel15.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel15.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel15.setText("max");
         jLabel15.setBounds(new Rectangle(254, 174, 43, 17));
         jLabel16.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel16.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel16.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel16.setText("n");
         jLabel16.setBounds(new Rectangle(317, 174, 43, 17));
         jLabel17.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel17.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel17.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel17.setText("mean");
          jLabel17.setBounds(new Rectangle(127, 384, 43, 17));
     jLabel18.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel18.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel18.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel18.setText("min");
         jLabel18.setBounds(new Rectangle(190, 384, 43, 17));
     jLabel19.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel19.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel19.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel19.setText("max");
         jLabel19.setBounds(new Rectangle(254, 384, 43, 17));
     jLabel20.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel20.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel20.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel20.setText("n");
         jLabel20.setBounds(new Rectangle(317, 384, 43, 17));

         jLabel21.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel21.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel21.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel21.setText("0");
         jLabel21.setBounds(new Rectangle(317, 403, 43, 17));
         jLabel22.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel22.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel22.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel22.setText("0");
         jLabel22.setBounds(new Rectangle(317, 193, 43, 17));
         jLabel23.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel23.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel23.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel23.setText("0.000");
         jLabel23.setBounds(new Rectangle(122, 190, 52, 23));
         jLabel24.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel24.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel24.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel24.setText("0.000");
         jLabel24.setBounds(new Rectangle(185, 190, 52, 23));
         jLabel25.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel25.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel25.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel25.setText("0.000");
         jLabel25.setBounds(new Rectangle(249, 190, 52, 23));
         jLabel26.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel26.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel26.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel26.setText("0.000");
         jLabel26.setBounds(new Rectangle(122, 400, 52, 23));
         jLabel27.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel27.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel27.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel27.setText("0.000");
         jLabel27.setBounds(new Rectangle(185, 400, 52, 23));
         jLabel28.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
         jLabel28.setHorizontalAlignment(SwingConstants.CENTER);
         jLabel28.setHorizontalTextPosition(SwingConstants.CENTER);
         jLabel28.setText("0.000");
         jLabel28.setBounds(new Rectangle(249, 400, 52, 23));
         jLabel29.setBackground(Color.lightGray);
         jLabel29.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel29.setText("Number of controls");
         jLabel29.setBounds(new Rectangle(12, 59, 112, 20));
         jLabel30.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel30.setText("Number of controls");
         jLabel30.setBounds(new Rectangle(12, 268, 115, 23));
         jTextField1.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jTextField1.setText("0.000");
          jTextField1.setBounds(new Rectangle(138, 218, 52, 23));
     jTextField1.setHorizontalAlignment(SwingConstants.CENTER);
     jTextField2.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jTextField2.setText("0.000");
         jTextField2.setBounds(new Rectangle(138, 257, 52, 23));

         jTextField2.setHorizontalAlignment(SwingConstants.CENTER);
     jCheckBox4.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jCheckBox4.setText("FRET min and max");
         jCheckBox4.setBounds(new Rectangle(12, 328, 173, 23));
         jLabel31.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel31.setText("Mean Donor BT");
         jLabel31.setBounds(new Rectangle(12, 217, 102, 25));
         jLabel32.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
         jLabel32.setText("Mean acceptor BT");
     jLabel32.setBounds(new Rectangle(12, 256, 112, 25));
     jPanel1.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
      jPanel1.setToolTipText("");
     jLabel35.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
     jLabel35.setText("Non-normalized FRET index image");
     jLabel35.setBounds(new Rectangle(12, 171, 200, 20));  // 12 171 175 20
     jLabel36.setFont(new java.awt.Font("Dialog", Font.PLAIN, 12));
     jLabel36.setToolTipText("");
     jLabel36.setText("Donor channel image");
     jLabel36.setBounds(new Rectangle(11, 60, 140, 15));
     jMenuBar1.add(jMenuFile);
           jMenuFile.add(jMenuFileRefresh);
          jMenuFile.add(jMenuFileExit);
          jMenuBar1.add(jMenuReset);
         jMenuReset.add(jMenuResetReset1);
          jMenuReset.add(jMenuResetReset2);

          jMenuBar1.add(jMenuHelp);
         jMenuHelp.add(jMenuHelpAbout);
         setJMenuBar(jMenuBar1);

          jTabbedPane1.setFont(new java.awt.Font("Dialog", Font.BOLD, 12));
           jTabbedPane1.add(jPanel1, "  Bleed Through  ");
     jPanel1.add(jLabel5);
     jPanel1.add(jLabel4);
     jPanel1.add(jComboBox4);
     jPanel1.add(jLabel2);
     jPanel1.add(jLabel29);
     jPanel1.add(jTextField3);
     jPanel1.add(jTextField4);
     jPanel1.add(jLabel6);
     jPanel1.add(jLabel13);
     jPanel1.add(jLabel14);
     jPanel1.add(jLabel15);
     jPanel1.add(jLabel16);
     jPanel1.add(jLabel30);
     jPanel1.add(jButton1);
     jPanel1.add(jLabel1);
     jPanel1.add(jComboBox2);
     jPanel1.add(jLabel3);
     jPanel1.add(jComboBox3);
     jPanel1.add(jLabel26);
     jPanel1.add(jLabel18);
     jPanel1.add(jLabel27);
     jPanel1.add(jLabel28);
     jPanel1.add(jLabel19);
     jPanel1.add(jLabel20);
     jPanel1.add(jLabel21);
     jPanel1.add(jButton2);
     jPanel1.add(jLabel23);
     jPanel1.add(jLabel24);
     jPanel1.add(jLabel25);
     jPanel1.add(jLabel22);
     jPanel1.add(jLabel10);
     jPanel1.add(jCheckBox2);
     jPanel1.add(jCheckBox3);
     jPanel1.add(jLabel11);
     jPanel1.add(jComboBox1);
     jPanel1.add(jLabel17);
     jTabbedPane1.add(jPanel2, "  FRET Calculation  "); // jPanel2.add(jLabel7);
     jPanel2.add(jLabel36);
     jPanel2.add(jComboBox5);
     jPanel2.add(jLabel8);
     jPanel2.add(jComboBox6);
     jPanel2.add(jLabel9);
     jPanel2.add(jComboBox7);
     jPanel2.add(jLabel35);
     jPanel2.add(jLabel31);
     jPanel2.add(jLabel32);
     jPanel2.add(jTextField1);
     jPanel2.add(jTextField2);
     jPanel2.add(jButton3);
     jPanel2.add(jCheckBox4);
     jPanel2.add(jCheckBox1);
     //  jPanel2.add(jComboBox8);
    // jPanel2.add(jLabel34);
     contentPane.add(jTabbedPane1, null);

  }

  private Object makeObj(final String item)  {
        return new Object() { public String toString() { return item; } };
  }


  void jMenuFileExit_actionPerformed(ActionEvent actionEvent) {
        this.dispose();
  }


  void jMenuResetReset1_actionPerformed(ActionEvent actionEvent) {

        jLabel23.setText("0.000");
        jTextField3.setText("1");
        jLabel24.setText("0.000");
        jLabel25.setText("0.000");
        jLabel22.setText("0");
        jTextField1.setText("0.000");

        if(this.jCheckBox2.isSelected()==false) this.jCheckBox2.setSelected(true);

        compt=0;
        compt=0;

        for(int i=0;i<10;i++)
               tab_coeff1[i]=-1;
   }


   void jMenuResetReset2_actionPerformed(ActionEvent actionEvent) {

        jLabel26.setText("0.000");
        jTextField4.setText("1");
        jLabel27.setText("0.000");
        jLabel28.setText("0.000");
        jLabel21.setText("0");
        jTextField2.setText("0.000");
        if(this.jCheckBox3.isSelected()==false) this.jCheckBox3.setSelected(true);

        compt2=0;
        for(int i=0;i<10;i++)
                tab_coeff2[i]=-1;

        index1 = this.jComboBox2.getSelectedIndex();
        index2 = this.jComboBox3.getSelectedIndex();

        imp1 = WindowManager.getImage(wList[index1]);
        imp2 = WindowManager.getImage(wList[index2]);
   }


   void jMenuFileRefresh_actionPerformed(ActionEvent actionEvent) {

        int count = 0;
        count= jComboBox1.getItemCount();
        if(count!=0){
                for(i=0;i<wList.length;i++) jComboBox1.removeAllItems();
                for(i=0;i<wList.length;i++) jComboBox2.removeAllItems();
                for(i=0;i<wList.length;i++) jComboBox3.removeAllItems();
                for(i=0;i<wList.length;i++) jComboBox4.removeAllItems();
                for(i=0;i<wList.length;i++) jComboBox5.removeAllItems();
                for(i=0;i<wList.length;i++) jComboBox6.removeAllItems();
                for(i=0;i<wList.length;i++) jComboBox7.removeAllItems();
        }

        wList = WindowManager.getIDList();
        titles = new String[wList.length];

        for (int i=0; i<wList.length; i++) {
            ImagePlus imp = WindowManager.getImage(wList[i]);
            if (imp!=null)
                titles[i] = imp.getTitle();
            else
                titles[i] = "";
        }

        for(i=0;i<wList.length;i++) jComboBox1.addItem(makeObj(titles[i]));
        for(i=0;i<wList.length;i++) jComboBox2.addItem(makeObj(titles[i]));
        for(i=0;i<wList.length;i++) jComboBox3.addItem(makeObj(titles[i]));
        for(i=0;i<wList.length;i++) jComboBox4.addItem(makeObj(titles[i]));
        for(i=0;i<wList.length;i++) jComboBox5.addItem(makeObj(titles[i]));
        for(i=0;i<wList.length;i++) jComboBox6.addItem(makeObj(titles[i]));
        for(i=0;i<wList.length;i++) jComboBox7.addItem(makeObj(titles[i]));
   }




   void jMenuHelpAbout_actionPerformed(ActionEvent actionEvent) {

        Frame_fret_AboutBox dlg = new Frame_fret_AboutBox(this);
        Dimension dlgSize = dlg.getPreferredSize();
        Dimension frmSize = getSize();
        Point loc = getLocation();
        dlg.setLocation( (frmSize.width  - dlgSize.width ) / 2 + loc.x,
                         (frmSize.height - dlgSize.height) / 2 + loc.y );
        dlg.setModal(true);
        dlg.pack();
        dlg.show();
   }


   void sort_array(int array[], int size){

        int i, j;
        int tmp1, tmp2;

        for (i = 0; i <= size - 2; i++) {
                for (j = i + 1; j <= size - 1; j++) {
                        if (array[i] >= array[j]) {
                                tmp1 = array[i];
                                tmp2 = array[j];
                                array[j] = tmp1;
                                array[i] = tmp2;
                        }
                }
        }
   }


   void sort_array(double array[], int size){

        int i,j;
        double  tmp1,tmp2;

        for(i=0;i<=size-2;i++){
                for(j=i+1;j<=size-1;j++){
                        if (array[i]>=array[j]){
                                tmp1=array[i];
                                tmp2=array[j];
                                array[j]=tmp1;
                                array[i]=tmp2;
                        }
                }
        }


    }


    public void jButton1_actionPerformed(ActionEvent e) {

        index1=this.jComboBox1.getSelectedIndex();
        index2=this.jComboBox4.getSelectedIndex();

        imp1 = WindowManager.getImage(wList[index1]);
        imp2 = WindowManager.getImage(wList[index2]);

        String n;
        String m;

        hist = new double[nbins];

        lo = 2.0 * Math.PI / 360.0 * loDegree;
        hi = 2.0 * Math.PI / 360.0 * hiDegree;
        off120 = 2.0 / 3.0 * Math.PI;
        off240 = 2.0 * off120;
        if(iswitch < 2) scaleIntensity = 1.0;
        scaleHue = (hi - lo) / PI2;
        binsize = PI2 / nbins;

        pixels1 = (byte[]) imp1.getProcessor().getPixels();
        pixels2 = (byte[]) imp2.getProcessor().getPixels();


        byte[] pixels11 =new byte[pixels1.length];
        byte[] pixels22=new byte[pixels2.length];

        for(i=0;i<pixels2.length;i++){
                pixels11[i]= pixels1[i];
                pixels22[i]= pixels2[i];

        }

        int w = imp1.getWidth();
        int h = imp1.getHeight();

        ip1 = imp1.getProcessor();
        ip2 = imp2.getProcessor();

        int width1 = imp1.getWidth();
        int height1 = imp1.getHeight();
        int width2 = imp2.getWidth();
        int height2 = imp2.getHeight();
        int pix1 = 0;
        int pix2 = 0;

        ImagePlus tmp1 = NewImage.createByteImage("tmp",width1,height1,1,NewImage.FILL_BLACK);
        ImageProcessor impt1 = tmp1.getProcessor();
        impt1.copyBits(ip1,0,0,Blitter.COPY);
        byte[] pixelst1 =(byte[])impt1.getPixels();

        ImagePlus tmp2 = NewImage.createByteImage("tmp2",width1,height1,1,NewImage.FILL_BLACK);
        ImageProcessor impt2 = tmp2.getProcessor();
        impt2.copyBits(ip2,0,0,Blitter.COPY);
        byte[] pixelst2 =(byte[])impt2.getPixels();

        double[] pix_d1 = new double[width1 * height1];
        double[] pix_d2 = new double[width2 * height2];

    // pour mettre tous les pixels entre 0 et 255

        for (i = 0; i < pixels1.length; i++) {
            pix1 = 0xff & pixels1[i];
            pix_d1[i] = pix1;
        }

        for (i = 0; i < pixels2.length; i++) {
            pix2 = 0xff & pixels2[i];
            pix_d2[i] = pix2;
        }

    // masque

        double[] mask1 = new double[width1 * height1];
        double[] mask2 = new double[width2 * height2];

    // median

        double[] median1 = new double[width1 * height1];
        double[] median2 = new double[width2 * height2];

        for (i = 0; i < width1 * height1; i++) {
            mask1[i] = 0;
            median1[i] = 0;
        }
        for (i = 0; i < width1 * height1; i++) {
            mask2[i] = 0;
            median2[i] = 0;
        }

        for (i = 0; i < width1 * height1; i++) {
            if (pix_d1[i] == 255) mask1[i] = 0;
            else mask1[i] = 1;

        }

        for (i = 0; i < width1 * height1; i++) {
            if (pix_d2[i] == 255) mask2[i] = 0;
            else mask2[i] = 1;
        }

    // image median1

        ImagePlus med1 = NewImage.createByteImage("med image", width2, height2, 1,
                                                        NewImage.FILL_BLACK);
        ImageProcessor med_ip1 = med1.getProcessor();
        med_ip1.copyBits(impt1, 0, 0, Blitter.COPY);
        byte[] pix_med1 = (byte[]) med_ip1.getPixels();

        med_ip1.medianFilter();

        double[] pix_m1 = new double[width2 * height2];
        for (i = 0; i < pix_med1.length; i++) {
                pix2 = 0xff & pix_med1[i];
                median1[i] = pix2;
        }


     // image median2

        ImagePlus med2 = NewImage.createByteImage("med image", width2, height2, 1,
                                                     NewImage.FILL_BLACK);
        ImageProcessor med_ip2 = med2.getProcessor();
        med_ip2.copyBits(impt2, 0, 0, Blitter.COPY);
        byte[] pix_med2 = (byte[]) med_ip2.getPixels();

        med_ip2.medianFilter();

        double[] pix_m2 = new double[width2 * height2];
        for (i = 0; i < pix_med2.length; i++) {
                pix2 = 0xff & pix_med2[i];
                median2[i] = pix2;
        }



        double[] res1= new double[width1*height1];
        double[] res2= new double[width2*height2];

    // multiplication des 2 masques

        for(i=0;i<width1*height1;i++)
                mask1[i]=mask2[i]*mask1[i];

    // multiplication median x masque

        for(i=0;i<width1*height1;i++)
                res1[i]=median1[i]*mask1[i];

        for(i=0;i<width2*height2;i++)
                res2[i]=median2[i]*mask1[i];


        for(int d=0;d<width1*height1;d++) pixels1[d]=(byte)res1[d];
        for(int eee=0;eee<width1*height1;eee++) pixels2[eee]=(byte)res2[eee];

        m=jTextField3.getText();
        if(Double.parseDouble(m)<1 || Double.parseDouble(m)>10) {IJ.showMessage("Controls between 1 and 10");return;}

        check4=true;

        n=Integer.toString(compt);
      //  for(i=0;i<10;i++) IJ.write(IJ.d2s(tmp[i]));
              //  IJ.write(m);

        if(Double.parseDouble(n)==Double.parseDouble(m)){
                IJ.showMessage("All controls done");
        }

        else      if(compt>=Double.parseDouble(m))
       IJ.showMessage("All controls done");

        else{ compt++;
                n=Integer.toString(compt);
                jLabel22.setText(n+"/"+m);

                //}

                if(this.jCheckBox2.isSelected()) {regressionGraph=true; showPalette=true; single=true;}
                else{regressionGraph=false; showPalette=false; single=false;}

                threshold = (int)(thresholdPercent/100 * ip1.getMax());
                doSingleImageComparison(w, h, single,compt,check4,m);

            // Show histogram

                for(int i=0; i<nbins; i++) hist[i] /= sumIntent;
                showHistogram(hist);

                double mu=0;
                double max =0;
                double min=0;
                for (i=0;i<10;i++) tmp[i]=0;

                for (i=0;i<10;i++) {
                        if (tab_coeff1[i] != 0 && tab_coeff1[i]!=-1) tmp[i] = tab_coeff1[i];
                        else  tmp[i]=-1;
                }


                if(regressionGraph) doGraph(w, h);

                if(Double.parseDouble(m)==1) {
                jLabel23.setText(IJ.d2s(tab_coeff1[0],3));
                jLabel24.setText(IJ.d2s(tab_coeff1[0],3));
                jLabel25.setText(IJ.d2s(tab_coeff1[0],3));
                jTextField1.setText(IJ.d2s(tab_coeff1[0],3));
        }

        if(compt<=Double.parseDouble(m) && Double.parseDouble(m)!=1){

                for (i=0;i<10;i++) {
                        if( tmp[i]!=-1)
                                mu+=tmp[i];
                        }
                        mu=mu/compt;

                        jLabel23.setText(IJ.d2s(mu,3));
                        jTextField1.setText(IJ.d2s(mu,3));
                        sort_array(tmp,10);

                    // min
                        for (i=0;i<10;i++) {
                                if(tmp[i]!=-1) {
                                        jLabel24.setText(IJ.d2s(tmp[i],3));
                                        break;
                                }
                        }

                    // max
                        jLabel25.setText(IJ.d2s(tmp[9],3));

                }
        }

    // recopie sauvegarde

        for(i=0;i<pixels2.length;i++){
                pixels1[i]= pixels11[i];
                pixels2[i]= pixels22[i];}
        }


    public void jButton2_actionPerformed(ActionEvent e) {

        index1=this.jComboBox2.getSelectedIndex();
        index2=this.jComboBox3.getSelectedIndex();

        imp1 = WindowManager.getImage(wList[index1]);
        imp2 = WindowManager.getImage(wList[index2]);

        hist = new double[nbins];

        lo = 2.0*Math.PI/360.0 * loDegree;
        hi = 2.0*Math.PI/360.0 * hiDegree;
        off120 = 2.0 / 3.0 * Math.PI;
        off240 = 2.0 * off120;
        if(iswitch < 2) scaleIntensity = 1.0;
        scaleHue = (hi - lo) / PI2;
        binsize = PI2 / nbins;

        check4=false;

        String nn;
        String mm;

        pixels1 = (byte[]) imp1.getProcessor().getPixels();
        pixels2 = (byte[]) imp2.getProcessor().getPixels();

        byte[] pixels11 =new byte[pixels1.length];
        byte[] pixels22=new byte[pixels2.length];

        for(i=0;i<pixels2.length;i++){
                pixels11[i]= pixels1[i];
                pixels22[i]= pixels2[i];
       }

        int w = imp1.getWidth();
        int h = imp1.getHeight();

        ip1 = imp1.getProcessor();
        ip2 = imp2.getProcessor();

        int width1 = imp1.getWidth();
        int height1 = imp1.getHeight();
        int width2 = imp2.getWidth();
        int height2 = imp2.getHeight();
        int pix1 = 0;
        int pix2 = 0;

        ImagePlus tmp1 = NewImage.createByteImage("tmp",width1,height1,1,NewImage.FILL_BLACK);
        ImageProcessor impt1 = tmp1.getProcessor();
        impt1.copyBits(ip1,0,0,Blitter.COPY);
        byte[] pixelst1 =(byte[])impt1.getPixels();

        ImagePlus tmp2 = NewImage.createByteImage("tmp2",width1,height1,1,NewImage.FILL_BLACK);
        ImageProcessor impt2 = tmp2.getProcessor();
        impt2.copyBits(ip2,0,0,Blitter.COPY);
        byte[] pixelst2 =(byte[])impt2.getPixels();

        double[] pix_d1 = new double[width1 * height1];
        double[] pix_d2 = new double[width2 * height2];

     // pour mettre tous les pixels entre 0 et 255

        for (i = 0; i < pixels1.length; i++) {
                pix1 = 0xff & pixels1[i];
                pix_d1[i] = pix1;
        }

        for (i = 0; i < pixels2.length; i++) {
                pix2 = 0xff & pixels2[i];
                pix_d2[i] = pix2;
        }

     // masque

        double[] mask1 = new double[width1 * height1];
        double[] mask2 = new double[width2 * height2];

     // median

        double[] median1 = new double[width1 * height1];
        double[] median2 = new double[width2 * height2];

        for (i = 0; i < width1 * height1; i++) {
                mask1[i] = 0;
                median1[i] = 0;
        }

        for (i = 0; i < width1 * height1; i++) {
                mask2[i] = 0;
                median2[i] = 0;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d1[i] == 255) mask1[i] = 0;
                else mask1[i] = 1;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d2[i] == 255) mask2[i] = 0;
                else mask2[i] = 1;
        }

     // image median1

        ImagePlus med1 = NewImage.createByteImage("med image", width2, height2, 1,
                                                          NewImage.FILL_BLACK);
        ImageProcessor med_ip1 = med1.getProcessor();
        med_ip1.copyBits(impt1, 0, 0, Blitter.COPY);
        byte[] pix_med1 = (byte[]) med_ip1.getPixels();

        med_ip1.medianFilter();

        double[] pix_m1 = new double[width2 * height2];
        for (i = 0; i < pix_med1.length; i++) {
                pix2 = 0xff & pix_med1[i];
                median1[i] = pix2;
        }

     // image median2

        ImagePlus med2 = NewImage.createByteImage("med image", width2, height2, 1,
                                                       NewImage.FILL_BLACK);
        ImageProcessor med_ip2 = med2.getProcessor();
        med_ip2.copyBits(impt2, 0, 0, Blitter.COPY);
        byte[] pix_med2 = (byte[]) med_ip2.getPixels();

        med_ip2.medianFilter();

        double[] pix_m2 = new double[width2 * height2];

        for (i = 0; i < pix_med2.length; i++) {
                pix2 = 0xff & pix_med2[i];
                median2[i] = pix2;
        }

        double[] res1= new double[width1*height1];
        double[] res2= new double[width2*height2];

     // multiplication des 2 masques

        for(i=0;i<width1*height1;i++)
                mask1[i]=mask2[i]*mask1[i];

     // multiplication median x masque

        for(i=0;i<width1*height1;i++)
                res1[i]=median1[i]*mask1[i];

        for(i=0;i<width2*height2;i++)
                res2[i]=median2[i]*mask1[i];

        for(int d=0;d<width1*height1;d++) pixels1[d]=(byte)res1[d];
        for(int eee=0;eee<width1*height1;eee++) pixels2[eee]=(byte)res2[eee];

        mm=jTextField4.getText();

        if(Double.parseDouble(mm)<1 || Double.parseDouble(mm)>10) {IJ.showMessage("Controls between 1 and 10");return;}

        nn=Integer.toString(compt2);

        if(Double.parseDouble(nn)==Double.parseDouble(mm)) {
                IJ.showMessage("All controls done");
        }

        else      if(compt2>=Double.parseDouble(mm))
       IJ.showMessage("All controls done");



        else{
                compt2++;
                nn=Integer.toString(compt2);


                jLabel21.setText(nn+"/"+mm);

                if(this.jCheckBox3.isSelected()) {regressionGraph=true; showPalette=true; single=true;}
                else{regressionGraph=false; showPalette=false; single=false;}

                threshold = (int)(thresholdPercent/100 * ip1.getMax());
                doSingleImageComparison(w, h, single,compt2,check4,mm);

        // Show histogram
                for(int i=0; i<nbins; i++) hist[i] /= sumIntent;
                        showHistogram(hist);

                double mu=0;
                double max =0;
                double min=0;
                for (i=0;i<10;i++) tmp[i]=0;

                for (i=0;i<10;i++) {
                        if (tab_coeff2[i] != 0 && tab_coeff2[i] != -1 ) tmp[i] = tab_coeff2[i];
                        else  tmp[i]=-1;
                }

                if(regressionGraph) doGraph(w, h);

                if(Double.parseDouble(mm)==1) {
                        jLabel26.setText(IJ.d2s(tab_coeff2[0],3));
                        jLabel27.setText(IJ.d2s(tab_coeff2[0],3));
                        jLabel28.setText(IJ.d2s(tab_coeff2[0],3));
                        jTextField2.setText(IJ.d2s(tab_coeff2[0],3));
                }

                if(compt2<=Double.parseDouble(mm) && Double.parseDouble(mm)!=1){

                for (i=0;i<10;i++) {
                        if( tmp[i]!=-1)
                        mu+=tmp[i];
                }

                mu=mu/compt2;
                jLabel26.setText(IJ.d2s(mu,3));
                jTextField2.setText(IJ.d2s(mu,3));
                sort_array(tmp,10);

        // min

                for (i=0;i<10;i++) {
                        if(tmp[i]!=-1) {
                                jLabel27.setText(IJ.d2s(tmp[i],3));
                                break;
                        }
                }

                jLabel28.setText(IJ.d2s(tmp[9],3)); //max





        }
    }


    for(i=0;i<pixels2.length;i++){
        pixels1[i]= pixels11[i];
        pixels2[i]= pixels22[i];
    }


  }


  public void jButton3_actionPerformed(ActionEvent e) {

    int ii=0;
    ii=this.jComboBox8.getSelectedIndex();

    i1Index=this.jComboBox5.getSelectedIndex();
    i2Index=this.jComboBox6.getSelectedIndex();
    i4Index=this.jComboBox7.getSelectedIndex();

    i1 = WindowManager.getImage(wList[i1Index]);
    i2 = WindowManager.getImage(wList[i2Index]);
    i4 = WindowManager.getImage(wList[i4Index]);

    int width1 = i1.getWidth();
    int width2 = i2.getWidth();
    int height1 = i1.getHeight();
    int height2 = i2.getHeight();

    imResu =  NewImage.createRGBImage("Composite_and_Mask",width1,height1,1,NewImage.FILL_BLACK);
    imgray = NewImage.createByteImage("Colocalized FRET index",width1,height1,1,NewImage.FILL_BLACK);
    im_fret = NewImage.createByteImage("Colocalization diagram and FRET",256,256,1,NewImage.FILL_BLACK);
    im_corr_mu = NewImage.createByteImage("FRET index", width1, height1, 1, NewImage.FILL_BLACK);
    im_corr_min = NewImage.createByteImage("Maximum FRET index", width1, height1, 1, NewImage.FILL_BLACK);
    im_corr_max = NewImage.createByteImage("Minimum FRET index", width1, height1, 1, NewImage.FILL_BLACK);


    String toto1;
    String toto2;
    String toto3;
    String toto4;
    String toto5;
    String toto6;
    //String totobg1;
   // String totobg2;
    //String totobg3;

    boolean min_max=false;

    toto1=jTextField1.getText();
    toto2=jTextField2.getText();
    toto3=jLabel24.getText();
    toto4=jLabel27.getText();
    toto5=jLabel25.getText();
    toto6=jLabel28.getText();
  //  totobg1=jTextField5.getText();
  //  totobg2=jTextField6.getText();
  //  totobg3=jTextField7.getText();

    double ki1=Double.parseDouble(toto1);
    double ki2=Double.parseDouble(toto2);
    double ki3=Double.parseDouble(toto3);
    double ki4=Double.parseDouble(toto4);
    double ki5=Double.parseDouble(toto5);
    double ki6=Double.parseDouble(toto6);
 //   double bg1=Double.parseDouble(totobg1);
 //   double bg2=Double.parseDouble(totobg2);
  //  double bg3=Double.parseDouble(totobg3);
  double bg1=0;
  double bg2=0;
  double bg3=0;

        // if(min_max==true)IJ.write("");

    if(this.jCheckBox4.isSelected()){min_max=true;}
    else min_max=false;

    col = new Coloc(i1, i2, i4, im_fret, imResu, imgray,im_corr_mu, im_corr_min, im_corr_max,min_max);
    col.fret_contol(i1, i2, i4, im_fret, im_corr_mu, im_corr_min, im_corr_max, ki1,ki2, ki3, ki4,ki5,ki6,bg1,bg2,bg3,ii,min_max);

    if(this.jCheckBox1.isSelected()) {col.calcul(i1, i2, i4, im_fret, imResu, im_corr_mu, im_corr_min, im_corr_max, min_max);}


  }


  public void jButton4_actionPerformed(ActionEvent e) {

        i1Index=this.jComboBox5.getSelectedIndex();

        i1 = WindowManager.getImage(wList[i1Index]);

        background = new Bg(i1,jTextField5);
        background.get_bg();

  }


  public void jButton5_actionPerformed(ActionEvent e) {

        i2Index=this.jComboBox6.getSelectedIndex();
        i2 = WindowManager.getImage(wList[i2Index]);

        background =new Bg(i2,jTextField6);
        background.get_bg();
  }


  public void jButton6_actionPerformed(ActionEvent e) {

        i2Index=this.jComboBox7.getSelectedIndex();
        i4 = WindowManager.getImage(wList[i2Index]);

        background =new Bg(i4,jTextField7);
        background.get_bg();
  }


  public void jTabbedPane1_focusGained(FocusEvent e) {

}




  void doSingleImageComparison(int w, int h, boolean single, int compt, boolean check4, String m) {

        int[] colorPixels = doColorComparison(pixels1, pixels2,compt,check4,m);

        ipPolar = new ColorProcessor(w, h);
        ipPolar.setPixels(colorPixels);
        ipPolar.setColor(Color.white);
        ipPolar.moveTo(10, 20);
        Font font = new Font("SansSerif", Font.BOLD, 16);
        ipPolar.setFont(font);
        colImage = new ImagePlus("Regression Control", ipPolar);

        if(single==true){
                colImage.show();
                colImage.updateAndDraw();
        }
  }




  double arcAngle(double x, double y){

        double ITTY = 0.000001;
        double angle = 0;

        if(x == 0) x = ITTY;
        angle = Math.atan(y / x);
        if(x < 0) angle += Math.PI;
        if(angle < 0) angle += 2*Math.PI;
        return angle;
  }


  int makeRGBPixel(int r, int g, int b){

        return 0xff000000 | ((r&0xff)<<16) | ((g&0xff)<<8) | b&0xff;
  }


 void showHistogram(double[] hist){

        double start = 0, inc = 0;
        DecimalFormat df = new DecimalFormat("00.0");
        String h = "";
        String s = "";

        if(mode==POLAR){
                inc = 90.0 / nbins;
                start = inc / 2;
                h += "Angle";
        }
        else if(mode == PERCENTAGE)
        {
                inc = 100.0 / nbins;
                start = inc / 2;
                h += "Percentage";
        }
        else  // Regression
        {
        inc = 1;
                start = -nbins / 2.0  + inc / 2;;
                h += "Standard Error";
        }

        for(int i=0; i<nbins; i++)
        {
                s += df.format(start) + "\t" +
                df.format(hist[i]*100) + "\n";
                start += inc;
        }
 }


 int[] doColorComparison(byte[] pixels1, byte[] pixels2, int compt, boolean check4, String m)
 {
        int[] colorPixels = new int[pixels1.length];

    // check for regression image

        if(mode == REGRESSION)
        {
                try
                {
                        s = new Compar(ip1, ip2, pixels1, pixels2, threshold);
                        s.show(tab_coeff1, tab_coeff2, compt, check4, m);
                }
                catch(Exception e)
                {
                        IJ.write("Regression failed.");
                        return null;
                }

            // color pixels in # se from prediction

                return colorErrors(s, pixels1, pixels2);
        }

        for(int x=0; x<pixels1.length; x++)
        {
                int v1 = (int)pixels1[x] & 255;
                int v2 = (int)pixels2[x] & 255;
                if((v1>0) || (v2>0))
                {
                        double intent = 0;
                        if(iswitch==0) intent = v1;
                        else if(iswitch==1) intent = v2;
                        else intent = scaleIntensity*Math.sqrt((double)(v1*v1) + (double)(v2*v2));
                        double polar = 0;
                        if(mode == 0) polar = arcAngle((double)v1, (double)v2);
                        else polar = PI2 * v2/(v1 + v2);  //  percentage

                  // increment histogram

                        int bin = (int)(polar / binsize);
                        if(bin < 0) bin = 0;
                        if(bin >= nbins) bin = nbins - 1;
                        if(weightHistogram)
                        {
                                hist[bin] += intent;
                                sumIntent += intent;
                        }
                        else
                        {
                                hist[bin]++;
                                sumIntent++;
                        }
                        double hue = lo + scaleHue*polar;
                        colorPixels[x] = makeColorPixel(hue, intent);
                }
                else colorPixels[x] = 0;
        }
        return colorPixels;
 }



 int makeColorPixel(double hue, double intent){

        int r = (int) (0.5 * intent * (1.0 + Math.cos(hue)));
        int g = (int) (0.5 * intent * (1.0 + Math.cos(hue - off120)));
        int b = (int) (0.5 * intent * (1.0 + Math.cos(hue - off240)));
        return makeRGBPixel(r, g, b);
 }


 int[] colorErrors(Compar s, byte[] pixels1, byte[] pixels2){

        int count = 0;
        double errorLimit = nbins / 2;
        double mid = (hi + lo) / 2;
        double f = (hi - lo) / (2 * errorLimit);
        int[] colorPixels = new int[pixels1.length];

        for(int i=0; i<pixels1.length; i++)
        {
                int xv = (int)pixels1[i] & 255;
                int yv = (int)pixels2[i] & 255;

                double y1 = yv - s.regress(xv);
                double ye = 0;
                if(s.se > 0) ye = y1 / s.se;
                if(ye < -errorLimit) ye = - errorLimit;
                if(ye > errorLimit) ye = errorLimit;
                double hue = mid + f*ye;
                double intent = 0;

                if(iswitch==0) intent = 100 + xv / 1.645;   // if(iswitch==0) intent = xv;

                else if(iswitch==1) intent = yv;
                else intent = scaleIntensity*Math.sqrt((double)(xv*xv) + (double)(yv*yv));
                colorPixels[i] = makeColorPixel(hue, intent);

           // increment histogram

                int bin = (int)Math.round(ye + errorLimit);
                if(bin < 0) bin = 0;
                if(bin >= nbins) bin = nbins - 1;
                if(weightHistogram)
                {
                        hist[bin] += intent;
                        sumIntent += intent;
                }
                else
                {
                        hist[bin]++;
                        sumIntent++;
                }
        }
        return colorPixels;
 }


 void log(String s){

        System.out.println(s);
 }


 double betai(double a, double b, double x)

 // returns the incomplete beta fuction (Numerical Recipes)
 {
        double bt;

        if(x<0 || x>1) 		nerror("bad x in betai!");
        if(x==0 || x==1) 	bt = 0;
        else
                bt = Math.exp(gamln(a+b) - gamln(a) - gamln(b) + a*Math.log(x) + b*Math.log(1 - x));
        if(x<(a+1)/(a+b+2)) 		// use continued fraction directly
                return bt*betacf(a,b,x)/a;
        else  				// use continued fraction after symetry transformation
                return 1 - bt*betacf(b,a,1-x)/b;
 }


 double betacf(double a, double b, double x)
 {
    // continued fraction for incomplete beta function

        final int MAXIT = 100;
        final double EPS = 3.0e-7;
        int m, m2;
        double aa,c,d,del,h,qab,qam,qap;

        qab = a + b;
        qap = a + 1.0;
        qam = a - 1.0;
        c = 1.0;
        d = 1.0 - qab*x/qap;
        if(Math.abs(d) < Double.MIN_VALUE) d = Double.MIN_VALUE;
        d = 1.0 / d;
        h = d;
        for(m=1; m<=MAXIT; m++)
        {
                m2 = 2*m;
                aa = m*(b-m)*x / ((qam + m2) * (a + m2));
                d = 1.0 + aa*d;
                if(Math.abs(d) < Double.MIN_VALUE) d = Double.MIN_VALUE;
                c = 1.0 + aa/c;
                if(Math.abs(c) < Double.MIN_VALUE) c = Double.MIN_VALUE;
                d = 1.0 / d;
                h *= d*c;
                aa = -(a+m)*(qab+m)*x / ((a+m2) * (qap+m2));
                d = 1.0 + aa*d;
                if(Math.abs(d) < Double.MIN_VALUE) d = Double.MIN_VALUE;
                c = 1.0 + aa/c;
                if(Math.abs(c) < Double.MIN_VALUE) c = Double.MIN_VALUE;
                d = 1.0 / d;
                del = d*c;
                h *= del;
                if(Math.abs(del-1.0) < EPS) break;
        }
        if(m > MAXIT) nerror("a or b too big, or MAXIT too smal in betacf");
        return h;
 }

 double gamln(double xx)
 {
        double x, y, tmp, ser;
        double cof[] =
          {
                76.18009172947146,
                -86.50532032941677,
                24.01409824083091,
                -1.231739572450155,
                0.1208650973866179e-2,
                -0.5395239384953e-5
          };

        y = x = xx;
        tmp = x + 5.5;
        tmp -= (x + 0.5) * Math.log(tmp);
        ser = 1.000000000190015;
        for(int j=0; j<6; j++) ser += cof[j] / ++y;
        return -tmp + Math.log(2.5066282746310005*ser/x);
 }


 void nerror(String s)
 {
        System.out.println(s);
        System.exit(-1);
 }


 public double tInverse(double p, double df)
 {
        final double eps = 0.0001;
        double pt = 1.0;
        double t = 2.0;
        double lo = 0;
        double hi = 60.0;
        int i = 0;

        while(Math.abs(p - pt) > eps)
        {
                t = (hi + lo) / 2.0;
                pt = betai(0.5*df, 0.5, df /(df + t*t));
            // IJ.write("tInv t=" + t + " p=" + pt + " lo=" + lo + " hi=" + hi);
                if(pt < p) hi = t;
                else lo = t;
                i++;
                if(i>50) break;
        }
        return t;
 }


 double xcorrect(double x)
 {
        double cxx = s.sxx / s.n;
        return Math.sqrt(1.0 + 1.0/s.n + ((x - s.xbar)*(x - s.xbar)) / cxx);
 }


 void doGraph(int w, int h)
 {
        double t = tInverse(alpha, s.n-2.0);
        int width = 256; int height = 256;

        pixels1 = (byte[]) imp1.getProcessor().getPixels();
        pixels2 = (byte[]) imp2.getProcessor().getPixels();

        for(int i=0; i<256; i++) xc[i] = xcorrect((double)i);

        int[] colorPixels = (int[]) colImage.getProcessor().getPixels();
        int[] graphPixels = new int[width*height];
        ColorProcessor ipGraph = new ColorProcessor(width, height);
        for(int i=0; i<graphPixels.length; i++) graphPixels[i] = 0;

        for(int i=0; i<pixels1.length; i++)
        {
                int v1 = (int)pixels1[i] & 255;
                int v2 = (int)pixels2[i] & 255;
                if(v1 >= threshold)
                {
                        int j = width*(height-1-v2) + v1;
                        graphPixels[j] = colorPixels[i];
                }
        }
        ipGraph.setPixels(graphPixels);  // points du fond
        ImagePlus graph = new ImagePlus("Regression graph", ipGraph);
        graph.setColor(new Color(127, 127, 127));
        ipGraph.drawLine(0, (int)(255-s.regress(0)), 255, (int)(255 - s.regress(255)));

    // plot confidence bands

        graph.setColor(Color.white);
        for(int x=0; x<width; x += 4)
        {
                double bw = t * s.se * xc[x];
                ipGraph.drawPixel(x, (int)(255 - s.regress(x) + bw)); 	//dessine pixel en (x,y)
                ipGraph.drawPixel(x, (int)(255 - s.regress(x) - bw));
        }
        graph.updateAndDraw();
        graph.show();
 }

}



/****************************************************************
 ****************************************************************
 *
 * classe menu about
 *
 *****************************************************************
 ****************************************************************/

class Frame_fret_AboutBox extends JDialog implements ActionListener {

JPanel panel1 = new JPanel();
 JPanel panel2 = new JPanel();
 JPanel insetsPanel1 = new JPanel();
 JPanel insetsPanel2 = new JPanel();
 JPanel insetsPanel3 = new JPanel();
 JButton button1 = new JButton();
 JLabel imageLabel = new JLabel();
 JLabel label1 = new JLabel();
 JLabel label2 = new JLabel();
 JLabel label3 = new JLabel();
 JLabel label4 = new JLabel();
 JLabel label5 = new JLabel();
 JLabel label6 = new JLabel();
 JLabel label7 = new JLabel();
 JLabel label8 = new JLabel();
 JLabel label9 = new JLabel();
 JLabel label10 = new JLabel();
 JLabel label11 = new JLabel();
 ImageIcon image1 = new ImageIcon();
 BorderLayout borderLayout1 = new BorderLayout();
 BorderLayout borderLayout2 = new BorderLayout();
 FlowLayout flowLayout1 = new FlowLayout();
 GridLayout gridLayout1 = new GridLayout();
 String product = " - FRET and Colocalization Analyzer -  ImageJ Plugin";
 String version = " Version 1.0";
 String copyright = " ESBS 2006";
 String comments1 = " Programer : Olivier Marchal";
 String comments2 = " Concept : Noel Converset";
 String comments3 = " Inspiration : Colocalization finder plugin by C. Laummonerie & J. Mutterer";
 String comments4 = "                        Color Comparison plugin by Bill O'Connell";
 String comments5 = "";
 String comments6 = " For further information please visit :   ";
 String comments7 = " http://recepteurs.u-strasbg.fr/upr9050_PHP/equipes/JLG/fret.php";
 String comments8 = "";

 public Frame_fret_AboutBox(Frame parent) {
   super(parent);
   try {
     setDefaultCloseOperation(DISPOSE_ON_CLOSE);
     jbInit();
   }
   catch (Exception exception) {
     exception.printStackTrace();
   }
 }

 public Frame_fret_AboutBox() {
   this(null);
 }

 private void jbInit() throws Exception {
 //  image1 = new ImageIcon("about.png");
 image1 = new ImageIcon(Frame_fret.class.getResource("/logo.gif"));
   imageLabel.setIcon(image1);
   setTitle("About FRET and Colocalization Analyzer");
   panel1.setLayout(borderLayout1);
   panel2.setLayout(borderLayout2);
   insetsPanel2.setBorder(BorderFactory.createEmptyBorder(10, 10, 10, 10));
   gridLayout1.setRows(10);
   gridLayout1.setColumns(1);
   label1.setText(product);
   label2.setText(version);
   label3.setText(copyright);
   label4.setText(comments1);
   label5.setText(comments2);
   label6.setText(comments3);
   label7.setText(comments4);
   label8.setText(comments5);
   label9.setText(comments6);
   label10.setText(comments7);
   label11.setText(comments8);

   insetsPanel3.setLayout(gridLayout1);
   insetsPanel3.setBorder(BorderFactory.createEmptyBorder(10, 60, 10, 10));
   button1.setText("Close");
   button1.addActionListener(this);
   insetsPanel2.add(imageLabel, null);
   panel2.add(insetsPanel2, BorderLayout.WEST);
   getContentPane().add(panel1, null);
   insetsPanel3.add(label1, null);
   insetsPanel3.add(label2, null);
   insetsPanel3.add(label3, null);
   insetsPanel3.add(label4, null);
   insetsPanel3.add(label5, null);
   insetsPanel3.add(label6, null);
   insetsPanel3.add(label7, null);
   insetsPanel3.add(label8, null);
   insetsPanel3.add(label9, null);
   insetsPanel3.add(label10, null);

   panel2.add(insetsPanel3, BorderLayout.CENTER);
   insetsPanel1.add(button1, null);
   panel1.add(insetsPanel1, BorderLayout.SOUTH);
   panel1.add(panel2, BorderLayout.NORTH);
   setResizable(true);
 }


 public void actionPerformed(ActionEvent actionEvent) {
   if (actionEvent.getSource() == button1) {
     dispose();
   }
 }
}




/****************************************************************
 ****************************************************************
 *
 * classe compar
 *
 *****************************************************************
 ****************************************************************/


  class Compar {

        double
                n = 0,
                sx=0, sy = 0,
                sxx=0, syy=0, sxy=0,
                xbar, ybar,
                a=0, b=0, se=0, r=0;
        double
                df, t, p;
        int rx, ry, w, h;
        byte[] mask;


        Compar(ImageProcessor ip1, ImageProcessor ip2,
                byte[] pixels1, byte[] pixels2, int threshold) throws Exception
        {

                if(ip1 != null)
                {
                        Rectangle roi = ip1.getRoi();
                        if(roi==null) IJ.write("roi is null");
                        else
                        {
                                mask = ip1.getMaskArray();
                                rx = (int)roi.getX(); ry = (int)roi.getY();
                                w = (int)roi.getWidth(); h = (int)roi.getHeight();
                        }
                }

                else throw new Exception("No imageProcessor");

                int i = 0;
                for(int y=ry; y<ry+h; y++)
                        for(int x=rx; x<rx+w; x++)
                        {
                                if((mask==null) || (mask[i++]!=0))
                        {
                        int vx = ip1.getPixel(x, y);
                        if(vx >= threshold)
                        {
                                int vy = ip2.getPixel(x, y);
                                n++;
                                sx += vx; sy += vy;
                                sxx += vx*vx; syy += vy*vy;
                                sxy += vx*vy;
                        }
                }
        }

        xbar = sx / n;
        ybar = sy / n;
        sxx = n*sxx -sx*sx; syy = n*syy - sy*sy; sxy = n*sxy -sx*sy;
        a = sxy / sxx;
        b = (sy - a*sx) / n;

  // Get standard error of estimate

        i = 0;
        for(int y=ry; y<ry+h; y++)
                for(int x=rx; x<rx+w; x++)
                {
                        if((mask==null) || (mask[i++]!=0))
                        {
                                int vx = ip1.getPixel(x, y);
                                if(vx >= threshold)
                        {
                int vy = ip2.getPixel(x, y);
                double ye = vy - a*vx - b;
                se += (ye * ye);
                }
        }


   }


  se = Math.sqrt(se / (n-2));


// Pearson r

  r = sxy / Math.sqrt(sxx * syy);

  }



  double regress(double x)
  {
        return b + a*x;
  }


  void show(double [] tab_coeff1,double [] tab_coeff2, int compt, boolean check4, String m)
  {
        DecimalFormat df = new DecimalFormat("##0.000");

        if (check4==true){
                IJ.write(" ");
                IJ.write("***   Donor BT control  "+compt+"/"+m);
                IJ.write(" Regression :  y = " + df.format(a) + "*x + " + df.format(b) +
             // "\nn = " + n +
                "\n Standard Error = " + df.format(se) + "    Pearson r = "
                + df.format(r));
        }
        else{
                IJ.write(" ");
                IJ.write("***   Acceptor BT control  "+compt+"/"+m);
                IJ.write(" Regression :  y = " + df.format(a) + "*x + " + df.format(b) +
             // "\nn = " + n +
                "\n Standard Error = " + df.format(se) + "    Pearson r = "
                + df.format(r));
        }


        int i=0;
        int mm=0;
        mm= (int)Double.parseDouble(m);
        double tt=-1;

        if(mm>1){
        for(i=mm;i<10;i++) {
                tab_coeff1[i]=tt;
                tab_coeff2[i]=tt;
        }


 }


   if(mm==1){

        if (check4==true)   tab_coeff1[0]=a;
        else tab_coeff2[0]=a;
   }
   else{
        if (check4==true) {tab_coeff1[compt-1]=a;}
        else  {tab_coeff2[compt-1]=a; }
   }



  }

} // end Compar




  /****************************************************************
   ****************************************************************
   *
   *  classe colocalisation
   *
   *****************************************************************
   ****************************************************************/



  class Coloc extends Fret_Analyzer{


        double r=1;
        boolean ratio=false,useThirdImage=false, pearson=true, fret_test=true;
        double[] lesx,lesy,ss;
        float[] xsample, ysample, a;
        float corr;
        int npixels;
        double aa=0;
        double bb=0;
        int i,counter,i1Index,i2Index,i3Index,i4Index;
        boolean min_max=false;
                int [] mini = new int[2];
        ImagePlus i1,  i2, i4, im_fret,imResu,imgray,im_corr_mu, im_corr_min, im_corr_max ;
        ImageProcessor ip;
        ImageCanvas canvas;

        Coloc(){}

  Coloc(ImagePlus i1, ImagePlus i2,ImagePlus i4,ImagePlus im_fret,ImagePlus imResu,ImagePlus imgray,ImagePlus im_corr_mu,  ImagePlus im_corr_min,  ImagePlus im_corr_max, 	boolean min_max)
  {
        this.i1 = i1;
        this.i2 = i2;
        this.i4 = i4;
        this.im_fret = im_fret;
        this.imResu=imResu;
        this.imgray=imgray;
        this.im_corr_mu=im_corr_mu;
        this.im_corr_min=im_corr_min;
        this.im_corr_max=im_corr_max;
        this.min_max=min_max;
  }


  void calcul(ImagePlus i1, ImagePlus i2, ImagePlus i4,ImagePlus im_fret, ImagePlus imResu, ImagePlus im_corr_mu, ImagePlus im_corr_min,ImagePlus im_corr_max, boolean min_max){

        int cpt=0;


        fret(i1,i2,i4,im_fret,im_corr_mu,im_corr_min,im_corr_max,min_max,mini);
        correlate(i1,i2,im_fret,im_corr_mu);

        ip = im_fret.getProcessor();
        ImageWindow win = im_fret.getWindow();
        canvas = win.getCanvas();
        canvas.addMouseListener(this);
        comparaison(cpt);
  }


  public void mouseReleased(MouseEvent e) {

        int cpt=1;
        comparaison(cpt);
  }


  void correlate(ImagePlus i1, ImagePlus i2,ImagePlus im_fret,ImagePlus im_corr_mu) {

        int width = i1.getWidth();
        int height = i1.getHeight();

        ImageProcessor ip1, ip2, ip3, ip4, i_fin;

        ip1 = i1.getProcessor();
        ip2 = i2.getProcessor();
        i_fin = im_fret.getProcessor();

        for (int y=0; y<height; y++) {
                for (int x=0; x<width; x++) {
                        int z1 = (int)ip1.getPixelValue(x,y);
                        int z2 = 256-(int)ip2.getPixelValue(x,y);
                        int count = (int)i_fin.getPixelValue(z1, z2);
                        count++;
                }
        }
        im_fret.show();

          String macro = null;
       try {

         InputStream is = Fret_Analyzer.class.getResourceAsStream("/macro/lut.txt");
              InputStreamReader isr = new InputStreamReader(is);

           StringBuffer sb = new StringBuffer();
           char [] b = new char [8192];
           int n;
           //read a block and append any characters
           while ((n = isr.read(b)) > 0)
               sb.append(b,0, n);

             macro = sb.toString();

       }

       catch (IOException e) {
           String msg = e.getMessage();
           if (msg==null || msg.equals(""))
               msg = "" + e;
           IJ.showMessage("Macro Runner", msg);
       }
       if (macro!=null)
           IJ.runMacro(macro, null);

        IJ.makeRectangle(50, 50, 150, 150);		//make the first rectangle selection on this image
  }




  void comparaison(int cpt) {

        if (!isSelection()) return;

        Rectangle coord;
        Roi rect;
        ImageProcessor ip1,ip2,IR_ip,dicIp,imu,igray;
        ip1= i1.getProcessor();
        ip2 = i2.getProcessor();
        IR_ip =imResu.getProcessor(); //Composite_and_Mask
        imu=im_corr_mu.getProcessor(); //FRET index moyenne
        igray=imgray.getProcessor(); //Colocalized FRET index
        int minI1, maxI1,maxI2,minI2,x,y,vi1,vi2,vDic,lon,lar,cid, dRed,dBlue,dGreen;
        lon = i1.getWidth();
        lar = i1.getHeight();
        rect = im_fret.getRoi();
        coord = rect.getBounds();


 coord.x=coord.x+mini[0];
 coord.y=coord.y-mini[1];

  if(coord.x>lar) coord.x=lar-1;
  if(coord.y<0) coord.y=0;

 //IJ.write(IJ.d2s(coord.x));
   //  IJ.write(IJ.d2s(coord.y));

        minI1=coord.x;
        minI2=256 - coord.y - coord.height;
        maxI1=coord.x + coord.width-1;
        maxI2=255 - coord.y;

        counter=0;
        int[] pixels = (int[]) IR_ip.getPixels();

        lesx = new double [i1.getWidth()*i1.getHeight()];
        lesy = new double [i1.getWidth()*i1.getHeight()];

        int[] pixels_cp = new int[pixels.length];
        for(i=0;i<pixels.length;i++)  pixels_cp[i] = pixels[i];

        int pix11=0;

        double[] pix_res=new double[pixels.length];

        byte[] pixels_gray =(byte[])igray.getPixels();
        double[] pix_g=new double[pixels.length];

        for(i=0;i<pixels_gray.length;i++){
                pix11 =  0xff  & pixels_gray[i] ;
                pix_g[i] = pix11;
        }

        // tableau image fret

        byte[] pixels_mu =(byte[])imu.getPixels();
        double[] pix_mu=new double[pixels_mu.length];

        for(i=0;i<pixels_mu.length;i++){
                pix11 =  0xff  & pixels_mu[i] ;
                pix_mu[i] = pix11;
        }

        for (y=0; y<lar; y++) {
                for (x=0; x<lon; x++) {
                        int pos = y*lon +x;
                        int c = pixels[pos];

                        boolean condition = false;
                        vi1 = (int) ip1.getPixelValue(x,y);
                        vi2 = (int) ip2.getPixelValue(x,y);

                        if (vi1>=minI1 && vi1<=maxI1 && vi2>=minI2 && vi2<=maxI2 ) condition=true;

                        if (condition) pix_res[pos]=pix_mu[pos];
                        else  pix_res[pos] = 0;
                }
        }

        for(i=0;i<pixels_mu.length;i++){
                if(pix_res[i]<=0) pix_res[i]=0;
                if(pix_res[i]>=255) pix_res[i]=255;
        }

        for(int d=0;d<pixels.length;d++) pixels_gray[d]=(byte)pix_res[d];

        imgray.show();
        imgray.updateAndDraw();
        if(cpt==0){
          macrolut1();
        }

        imgray.setProcessor(null, igray);
   }


   boolean isSelection() {

          if (im_fret==null) return false;
          Roi roi = im_fret.getRoi();

          if (roi==null) return false;
          int roiType = roi.getType();

          if (roiType == Roi.RECTANGLE)
            return true;
          else return false;

   }


// construction diagramme
 void fret(ImagePlus i1, ImagePlus i2,ImagePlus i4, ImagePlus im_fret,ImagePlus im_corr_mu,ImagePlus im_corr_min,ImagePlus im_corr_max,boolean min_max, int[] mini){


        int i=0;
        int j=0;
        int k=0;
        double pix1=0;
        double pix2=0;
        double pix4=0;
        int x=0; 	// coordonnee cfp
        int y=0; 	// coordonnee yfp
        int z=0; 	// intensite  fret
        int cpt=0;
        int somme=0;
        int toto=100;


        int width1 = i1.getWidth();
        int height1= i1.getHeight();
        int width2 = i2.getWidth();
        int height2= i2.getHeight();
        int width4 = i4.getWidth();
        int height4= i4.getHeight();
        int pix11=0;
        int pix22=0;
        int pix44=0;

        ImageProcessor ip1 = i1.getProcessor();
        ImageProcessor ip2 = i2.getProcessor();
        ImageProcessor ip4 = i4.getProcessor();
        ImageProcessor ipfret = im_corr_mu.getProcessor();

    //stockage des pixels dans tableau

        byte[] pixels1 =(byte[])ip1.getPixels();
        byte[] pixels2 =(byte[])ip2.getPixels();
        byte[] pixels4 =(byte[])ip4.getPixels();
        byte[] pixels_fret =(byte[])ipfret.getPixels();

   //save

        byte[] pixels11 =new byte[pixels1.length];
        byte[] pixels22=new byte[pixels2.length];
        byte[] pixels44=new byte[pixels4.length];
        byte[] pixels_fret2=new byte[pixels_fret.length];

        for(i=0;i<pixels2.length;i++){
                pixels11[i]= pixels1[i];
                pixels22[i]= pixels2[i];
                pixels44[i]= pixels4[i];
                pixels_fret2[i]= pixels_fret[i];
        }

   // masque

        double[] mask1 = new double[width1 * height1];
        double[] mask2 = new double[width2 * height2];
        double[] mask4 = new double[width2 * height2];

   // median

        double[] median1= new double[width1*height1];
        double[] median2= new double[width1*height1];
        double[] median4= new double[width1*height1];

   // resultat

        double[] res1= new double[width1*height1];
        double[] res2= new double[width1*height1];
        double[] res4= new double[width1*height1];

        for (i = 0; i < width1 * height1; i++) {
                mask1[i] = 0;
                median1[i] = 0;
                mask2[i] = 0;
                median2[i] = 0;
                mask4[i] = 0;
                median4[i] = 0;
                res1[i]=0;
                res2[i]=0;
                res4[i]=0;
        }

        double[] pix_d1= new double[width1*height1];
        double[] pix_d2= new double[width2*height4];
        double[] pix_d4= new double[width4*height4];
        double[] pix_dfret= new double[width4*height4];
        double big[][][]=new double[256][256][toto];
        double big2[] = new double[256*256];

        for(i=0;i<256;i++)
        for(j=0;j<256;j++)
        for(k=0;k<toto;k++)
        big[i][j][k]=0;

        for(i=0;i<256*256;i++) big2[i]=0;

        // pour mettre tous les pixels entre 0 et 255

        for(i=0;i<pixels1.length;i++){
                pix1 =  0xff  & pixels1[i] ;
                pix_d1[i] = pix1;
        }

        for(i=0;i<pixels2.length;i++){
                pix2 =  0xff  & pixels2[i] ;
                pix_d2[i] = pix2;
        }

        for(i=0;i<pixels4.length;i++){
                pix4 =  0xff  & pixels4[i] ;
                pix_d4[i] = pix4;
        }

        for(i=0;i<pixels_fret.length;i++){
                pix4 =  0xff  & pixels_fret[i] ;
                pix_dfret[i] = pix4;
        }

        // image median1

              ImagePlus med = NewImage.createByteImage("med image", width1, height1, 1,
                                                            NewImage.FILL_BLACK);
              ImageProcessor med_ip = med.getProcessor();
              med_ip.copyBits(ip1, 0, 0, Blitter.COPY);
              byte[] pix_med = (byte[]) med_ip.getPixels();

              med_ip.medianFilter();

              for (i = 0; i < pix_med.length; i++) {
                      pix1 = 0xff & pix_med[i];
                      median1[i] = pix1;
              }

              // image median2

              ImagePlus med2 = NewImage.createByteImage("med image", width2, height2, 1,
                                                             NewImage.FILL_BLACK);
              ImageProcessor med_ip2 = med2.getProcessor();
              med_ip2.copyBits(ip2, 0, 0, Blitter.COPY);
              byte[] pix_med2 = (byte[]) med_ip2.getPixels();

              med_ip2.medianFilter();

              for (i = 0; i < pix_med2.length; i++) {
                      pix2 = 0xff & pix_med2[i];
                     median2[i] = pix2;
              }

              ImagePlus med4 = NewImage.createByteImage("med image4", width2, height2, 1,
                                                            NewImage.FILL_BLACK);
              ImageProcessor med_ip4 = med4.getProcessor();
              med_ip4.copyBits(ip4, 0, 0, Blitter.COPY);
              byte[] pix_med4 = (byte[]) med_ip4.getPixels();

              med_ip4.medianFilter();

              for (i = 0; i < pix_med4.length; i++) {
                      pix4 = 0xff & pix_med4[i];
                      median4[i] = pix4;
        }



     //   med2.show();
      //  med2.updateAndDraw();

      double mini1=255;
        double mini2=255;
      for(i=0;i<pixels1.length;i++)
      {if(median1[i]<mini1 && median1[i]!=0)  mini1=median1[i];}

for(i=0;i<pixels1.length;i++)
        {if(median2[i]<mini2  && median2[i]!=0)  mini2=median2[i];}
    //    IJ.write("toto");
  //  IJ.write(IJ.d2s(mini1));
 //IJ.write(IJ.d2s(mini2));
  //IJ.write("toto");
    for(i=0;i<pixels1.length;i++)    {if(median1[i]!=0) median1[i]=median1[i]-mini1;}
    for(i=0;i<pixels2.length;i++)    { if(median2[i]!=0)median2[i]=median2[i]-mini2;}

mini[0]=(int)mini1;
mini[1]=(int)mini2;


        for (i = 0; i < width1 * height1; i++) {
                if (pix_d1[i] == 255) mask1[i] = 0;
                else mask1[i] = 1;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d2[i] == 255) mask2[i] = 0;
                else mask2[i] = 1;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d4[i] == 255) mask4[i] = 0;
                else mask4[i] = 1;
        }

        for (i = 0; i < width1 * height1; i++)
        mask1[i]=mask1[i]*mask2[i]*mask4[i];

        for (i = 0; i < width1 * height1; i++){
                res1[i]=median1[i]*mask1[i];
                res2[i]=median2[i]*mask1[i];
                res4[i]=median4[i]*mask1[i];
        }

        for(i=0;i<width1 * height1;i++){
                x=(int)res1[i];
                y=(int)res2[i];
                z=(int)pix_dfret[i];

                for(j=0;j<toto;j++){
                        if( big[x][y][j]==0) big[x][y][j]=z;
                }

        }

        cpt=0;

        // moyennage de la profondeur

        for(i=0;i<256;i++){
                for(j=0;j<256;j++){
                        somme=0; cpt=0;
                        for(k=0;k<toto;k++) {
                                if( big[i][j][k]!=0) {somme+=big[i][j][k]; cpt++;}
                                if(cpt==0) cpt=1;
                                big[i][j][0]=somme/cpt;
                        }
                }
        }

        ImageProcessor fin_ip = im_fret.getProcessor();
        byte[] pixels =(byte[])fin_ip.getPixels();

        for(i=0;i<256;i++){
                for(j=0;j<256;j++){
                        if(big[i][j][0]<0) big[i][j][0]=0;
                        if(big[i][j][0]>255) big[i][j][0]=255;
                }
        }

        for(i=0;i<256;i++)
                for(j=0;j<256;j++)
                        big2[j+i*256]=big[i][j][0];

        for(int d=0;d<256*256;d++) pixels[d]=(byte)big2[d];

        fin_ip.rotate(270);


       for(i=0;i<pixels2.length;i++){
             pixels1[i]= pixels11[i];
             pixels2[i]= pixels22[i];
             pixels4[i]= pixels44[i];
             pixels_fret[i]= pixels_fret2[i];
       }

    }



    void fret_contol(ImagePlus i1, ImagePlus i2,ImagePlus i4, ImagePlus im_fret, ImagePlus im_corr_mu, ImagePlus im_corr_min, ImagePlus im_corr_max, double ki1, double ki2, double ki3,double ki4,double ki5,double ki6, double bg1, double bg2, double bg3,int ii, boolean min_max){

        int i,counter,i1Index,i2Index;

        int width1 = i1.getWidth();
        int height1 = i1.getHeight();
        int width2 = i2.getWidth();
        int height2 = i2.getHeight();
        int pix1 = 0;
        int pix2 = 0;
        int pix4 = 0;

        ImageProcessor ip1 = i1.getProcessor();
        ImageProcessor ip2 = i2.getProcessor();
        ImageProcessor ip4 = i4.getProcessor();

        // stockage des pixels dans tableau

        byte[] pixels1 = (byte[]) ip1.getPixels();
        byte[] pixels2 = (byte[]) ip2.getPixels();
        byte[] pixels4 = (byte[]) ip4.getPixels();

        byte[] pixels11 =new byte[pixels1.length];
        byte[] pixels22=new byte[pixels2.length];
        byte[] pixels44=new byte[pixels4.length];

        for(i=0;i<pixels2.length;i++){
                pixels11[i]= pixels1[i];
                pixels22[i]= pixels2[i];
                pixels44[i]= pixels4[i];
        }

        double[] pix_d1 = new double[width1 * height1];
        double[] pix_d2 = new double[width2 * height2];
        double[] pix_d4 = new double[width2 * height2];

        // pour mettre tous les pixels entre 0 et 255

        for (i = 0; i < pixels1.length; i++) {
                pix1 = 0xff & pixels1[i];
                pix_d1[i] = pix1;
        }

        for (i = 0; i < pixels2.length; i++) {
                pix2 = 0xff & pixels2[i];
                pix_d2[i] = pix2;
        }

        for (i = 0; i < pixels4.length; i++) {
                pix4 = 0xff & pixels4[i];
                pix_d4[i] = pix4;
        }




       // masque

        double[] mask1 = new double[width1 * height1];
        double[] mask2 = new double[width2 * height2];
        double[] mask4 = new double[width2 * height2];

       // median

        double[] median1 = new double[width1 * height1];
        double[] median2 = new double[width2 * height2];
        double[] median4 = new double[width2 * height2];

        for (i = 0; i < width1 * height1; i++) {
                mask1[i] = 0;
                median1[i] = 0;
                mask2[i] = 0;
                median2[i] = 0;
                mask4[i] = 0;
                median4[i] = 0;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d1[i] == 255) mask1[i] = 0;
                else mask1[i] = 1;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d2[i] == 255) mask2[i] = 0;
                else mask2[i] = 1;
        }

        for (i = 0; i < width1 * height1; i++) {
                if (pix_d4[i] == 255) mask4[i] = 0;
                else mask4[i] = 1;
        }

        // image median1

        ImagePlus med = NewImage.createByteImage("med image", width1, height1, 1,
                                                      NewImage.FILL_BLACK);
        ImageProcessor med_ip = med.getProcessor();
        med_ip.copyBits(ip1, 0, 0, Blitter.COPY);
        byte[] pix_med = (byte[]) med_ip.getPixels();

        med_ip.medianFilter();

        double[] pix_m1 = new double[width1 * height1];
        for (i = 0; i < pix_med.length; i++) {
                pix1 = 0xff & pix_med[i];
                pix_m1[i] = pix1;
        }

        // image median2

        ImagePlus med2 = NewImage.createByteImage("med image", width2, height2, 1,
                                                       NewImage.FILL_BLACK);
        ImageProcessor med_ip2 = med2.getProcessor();
        med_ip2.copyBits(ip2, 0, 0, Blitter.COPY);
        byte[] pix_med2 = (byte[]) med_ip2.getPixels();

        med_ip2.medianFilter();

        double[] pix_m2 = new double[width2 * height2];
        for (i = 0; i < pix_med2.length; i++) {
                pix2 = 0xff & pix_med2[i];
                pix_m2[i] = pix2;
        }

        ImagePlus med4 = NewImage.createByteImage("med image4", width2, height2, 1,
                                                      NewImage.FILL_BLACK);
        ImageProcessor med_ip4 = med4.getProcessor();
        med_ip4.copyBits(ip4, 0, 0, Blitter.COPY);
        byte[] pix_med4 = (byte[]) med_ip4.getPixels();

        med_ip4.medianFilter();

        double[] pix_m4 = new double[width2 * height2];
        for (i = 0; i < pix_med4.length; i++) {
                pix4 = 0xff & pix_med4[i];
                pix_m4[i] = pix4;
        }


        double mini1=255;
         double mini2=255;
       for(i=0;i<pixels1.length;i++)
       {if(pix_m1[i]<mini1 && pix_m1[i]!=0)  mini1=pix_m1[i];}

 for(i=0;i<pixels1.length;i++)
         {if(pix_m2[i]<mini2  && pix_m2[i]!=0)  mini2=pix_m2[i];}
     //    IJ.write("toto");
   //  IJ.write(IJ.d2s(mini1));
  // IJ.write(IJ.d2s(mini2));
   //IJ.write("toto");
     for(i=0;i<pixels1.length;i++)  {if  (pix_m1[i]!=0) pix_m1[i]=pix_m1[i]-mini1;}
     for(i=0;i<pixels2.length;i++)  { if(pix_m2[i]!=0)  pix_m2[i]=pix_m2[i]-mini2;}


        // matrice rsultat

        double[] res1= new double[width1*height1];
        double[] res2= new double[width2*height2];
        double[] res4= new double[width2*height2];

        double[] res3 = new double[width1 * height1];
        for(i=0;i<width1*height1;i++) res3[i]=0;

        for(i=0;i<width1*height1;i++)
                mask1[i]=mask1[i]*mask2[i]*mask4[i];

        // multiplication median x masque

        for(i=0;i<width1*height1;i++)
                res1[i]=pix_m1[i]*mask1[i];

        for(i=0;i<width2*height2;i++)
                res2[i]=pix_m2[i]*mask1[i];

        for(i=0;i<width2*height2;i++)
                res4[i]=pix_m4[i]*mask1[i];


        // image finale

        ImageProcessor fin_ip_mu = im_corr_mu.getProcessor();
        byte[] pix_fin_mu = (byte[]) fin_ip_mu.getPixels();

        ImageProcessor fin_ip_min = im_corr_min.getProcessor();
        byte[] pix_fin_min = (byte[]) fin_ip_min.getPixels();

        ImageProcessor fin_ip_max = im_corr_max.getProcessor();
        byte[] pix_fin_max = (byte[]) fin_ip_max.getPixels();


        double[] res50=new double[width1*height1]; //denominateur


        // image moyenne
ii=0;
        if(ii==0){ //noel
                for(i=0;i<width1*height1;i++) res3[i]=res1[i]*ki1 + res2[i]*ki2;
                for(i=0;i<width2*height2;i++) res3[i]=res4[i]-res3[i];
        }

        if(ii==1) { //youvan
                for(i=0;i<width1*height1;i++) res3[i]=(res1[i]-bg1)*ki1  + (res2[i]-bg2)*ki2;
                for(i=0;i<width2*height2;i++) res3[i]=res4[i]-res3[i]-bg3;
        }


        if(ii==2){ //gordon
                for(i=0;i<width1*height1;i++) res3[i]=(res1[i]-bg1)*ki1  + (res2[i]-bg2)*ki2;
                for(i=0;i<width2*height2;i++) res3[i]=res4[i]-res3[i]-bg3;
                for(i=0;i<width2*height2;i++) res50[i]=(res1[i]-bg1)*(res2[i]-bg2);
                for(i=0;i<width2*height2;i++) {
                        if(res50[i]!=0) res3[i]=res3[i]/res50[i];
                        else   res3[i]=1;
                }
        }

        if(ii==3){ //xia
                for(i=0;i<width1*height1;i++) res3[i]=(res1[i]-bg1)*ki1  + (res2[i]-bg2)*ki2;
                for(i=0;i<width2*height2;i++) res3[i]=res4[i]-res3[i]-bg3;
                for(i=0;i<width2*height2;i++) res50[i]=Math.sqrt((res1[i]-bg1)*(res2[i]-bg2));
                for(i=0;i<width2*height2;i++) {
                        if(res50[i]!=0) res3[i]=res3[i]/res50[i];
                        else   res3[i]=1;
                }
        }

        if(ii==4){ //acc alone
                for(i=0;i<width1*height1;i++) res3[i]=(res1[i]-bg1)*ki1  + (res2[i]-bg2)*ki2;
                for(i=0;i<width2*height2;i++) res3[i]=res4[i]-res3[i]-bg3;
                for(i=0;i<width2*height2;i++) res50[i]=(res1[i]-bg1);
                for(i=0;i<width2*height2;i++) {
                        if(res50[i]!=0) res3[i]=res3[i]/res50[i];
                        else   res3[i]=1;
                }
        }

        for(i=0;i<height1*width1;i++){
                if(res3[i]<=0) res3[i]=0;
                if(res3[i]>=255) res3[i]=255;
        }

        for(int d=0;d<width1*height1;d++) pix_fin_mu[d]=(byte)res3[d];

        im_corr_mu.show();
        im_corr_mu.updateAndDraw();
      //  IJ.run("Enhance Contrast", "saturated=0.5");
       // IJ.run("Fire");
      // IJ.runPlugIn("ij.plugin.Macro_Runner", "JAR:lut.txt");
       macrolut();


           // image min

        if(min_max==true && ki3!=0 && ki4!=0 && ki5!=0 && ki6!=0){
          if (ki1 != ki3 || ki1 != ki5) {
            if (ki2 != ki4 || ki1 != ki6) {

              if (ii == 0) { //noel
                for (i = 0; i < width1 * height1; i++) res3[i] = res1[i] * ki3 +
                    res2[i] * ki4;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] - res3[i];
              }

              if (ii == 1) { //youvan
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) * ki3 +
                    (res2[i] - bg2) * ki4;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] - res3[i] -
                    bg3;
              }

              if (ii == 2) { //gordon
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) * ki3 +
                    (res2[i] - bg2) * ki4;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] - res3[i] -
                    bg3;
                for (i = 0; i < width2 * height2; i++) res50[i] = (res1[i] - bg1) *
                    (res2[i] - bg2);
                for (i = 0; i < width2 * height2; i++) {
                  if (res50[i] != 0) res3[i] = res3[i] / res50[i];
                  else res3[i] = 1;
                }
              }

              if (ii == 3) { //xia
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) * ki3 +
                    (res2[i] - bg2) * ki4;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] - res3[i] -
                    bg3;
                for (i = 0; i < width2 * height2; i++) res50[i] = Math.sqrt( (res1[i] -
                    bg1) * (res2[i] - bg2));
                for (i = 0; i < width2 * height2; i++) {
                  if (res50[i] != 0) res3[i] = res3[i] / res50[i];
                  else res3[i] = 1;
                }
              }

              if (ii == 4) { //acc alone
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) * ki3 +
                    (res2[i] - bg2) * ki4;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] - res3[i] -
                    bg3;
                for (i = 0; i < width2 * height2; i++) res50[i] = (res1[i] - bg1);
                for (i = 0; i < width2 * height2; i++) {
                  if (res50[i] != 0) res3[i] = res3[i] / res50[i];
                  else res3[i] = 1;
                }
              }

              for (i = 0; i < height1 * width1; i++) {
                if (res3[i] <= 0) res3[i] = 0;
                if (res3[i] >= 255) res3[i] = 255;
              }

              for (int d = 0; d < width1 * height1; d++) pix_fin_min[d] = (byte) res3[d];
              im_corr_min.show();
              im_corr_min.updateAndDraw();
              // IJ.run("Enhance Contrast", "saturated=0.5");
              // IJ.run("Fire");
           //   IJ.runPlugIn("ij.plugin.Macro_Runner", "JAR:lut.txt");
               macrolut();

            }

          }
        }
        // image max

        if(min_max==true && ki3!=0 && ki4!=0 && ki5!=0 && ki6!=0){
          if (ki1 != ki3 || ki1 != ki5) {
            if (ki2 != ki4 || ki1 != ki6) {

              if (ii == 0) { //noel
                for (i = 0; i < width1 * height1; i++) res3[i] = res1[i] * ki5 +
                    res2[i] * ki6;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] -
                    res3[i];
              }

              if (ii == 1) { //youvan
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) *
                    ki5 + (res2[i] - bg2) * ki6;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] -
                    res3[i] - bg3;
              }

              if (ii == 2) { //gordon
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) *
                    ki5 + (res2[i] - bg2) * ki6;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] -
                    res3[i] - bg3;
                for (i = 0; i < width2 * height2; i++) res50[i] = (res1[i] -
                    bg1) * (res2[i] - bg2);
                for (i = 0; i < width2 * height2; i++) {
                  if (res50[i] != 0) res3[i] = res3[i] / res50[i];
                  else res3[i] = 1;
                }
              }

              if (ii == 3) { //xia
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) *
                    ki5 + (res2[i] - bg2) * ki6;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] -
                    res3[i] - bg3;
                for (i = 0; i < width2 * height2; i++) res50[i] = Math.sqrt( (
                    res1[i] - bg1) * (res2[i] - bg2));
                for (i = 0; i < width2 * height2; i++) {
                  if (res50[i] != 0) res3[i] = res3[i] / res50[i];
                  else res3[i] = 1;
                }
              }

              if (ii == 4) { //acc alone
                for (i = 0; i < width1 * height1; i++) res3[i] = (res1[i] - bg1) *
                    ki5 + (res2[i] - bg2) * ki6;
                for (i = 0; i < width2 * height2; i++) res3[i] = res4[i] -
                    res3[i] - bg3;
                for (i = 0; i < width2 * height2; i++) res50[i] = (res1[i] -
                    bg1);
                for (i = 0; i < width2 * height2; i++) {
                  if (res50[i] != 0) res3[i] = res3[i] / res50[i];
                  else res3[i] = 1;
                }
              }

              for (i = 0; i < height1 * width1; i++) {
                if (res3[i] <= 0) res3[i] = 0;
                if (res3[i] >= 255) res3[i] = 255;
              }

              for (int d = 0; d < width1 * height1; d++) pix_fin_max[d] = (byte)
                  res3[d];
              im_corr_max.show();
              im_corr_max.updateAndDraw();
              //IJ.runPlugIn("ij.plugin.Macro_Runner", "JAR:lut.txt");
              //    IJ.run("Enhance Contrast", "saturated=0.5");
              //  IJ.run("Fire");

  macrolut();


            }
          }
        }
        for(i=0;i<pixels2.length;i++){
                pixels1[i]= pixels11[i];
                pixels2[i]= pixels22[i];
                pixels4[i]= pixels44[i];
        }

 }



 void macrolut(){

   String macro = null;
	try {

		InputStream is = Fret_Analyzer.class.getResourceAsStream("/macro/lut.txt");
 		InputStreamReader isr = new InputStreamReader(is);

		StringBuffer sb = new StringBuffer();
		char [] b = new char [8192];
		int n;

	     // read a block and append any characters

		while ((n = isr.read(b)) > 0)
		sb.append(b,0, n);

	     // display the text in a TextWindow

		macro = sb.toString();

	     // new TextWindow("Macro Runner", sb.toString(), 450, 450);

	}

	catch (IOException e) {
		String msg = e.getMessage();
		if (msg==null || msg.equals(""))
  		msg = "" + e;
		IJ.showMessage("Macro Runner", msg);
	}

	if (macro!=null)
	IJ.runMacro(macro, null);


 }




 void macrolut1(){

   String macro = null;
	try {

		InputStream is = Fret_Analyzer.class.getResourceAsStream("/macro/lut1.txt");
 		InputStreamReader isr = new InputStreamReader(is);

		StringBuffer sb = new StringBuffer();
		char [] b = new char [8192];
		int n;

	     // read a block and append any characters

		while ((n = isr.read(b)) > 0)
		sb.append(b,0, n);

	     // display the text in a TextWindow

		macro = sb.toString();

	     // new TextWindow("Macro Runner", sb.toString(), 450, 450);

	}

	catch (IOException e) {
		String msg = e.getMessage();
		if (msg==null || msg.equals(""))
  		msg = "" + e;
		IJ.showMessage("Macro Runner", msg);
	}

	if (macro!=null)
	IJ.runMacro(macro, null);


 }


}//class coloc



/****************************************************************
 ****************************************************************
 *
 * classe bg
 *
 *****************************************************************
 ****************************************************************/


  class Bg  extends Fret_Analyzer {

        ImagePlus i1 ;
        ImageProcessor ip;
        ImageCanvas canvas;
        Rectangle coord;
        JLabel jLabel24;
        JTextField jTextField6;
        Roi rect;

        Bg(){}


        Bg(ImagePlus i1, JTextField jTextField6)
        {
                this.i1 = i1;
                this.jTextField6 =jTextField6;

                ip =i1.getProcessor();

                i1.show();
                i1.updateAndDraw();
                i1.setRoi(50, 50, 150, 150);

                ImageWindow win = i1.getWindow();
                canvas = win.getCanvas();
                canvas.addMouseListener(this);

        }


        public void mouseReleased(MouseEvent e) {
                get_bg();
        }

        public void mousePressed(MouseEvent e) {}
        public void mouseExited(MouseEvent e)  {}
        public void mouseClicked(MouseEvent e) {}
        public void mouseEntered(MouseEvent e) {}


        void get_bg(){

                rect = i1.getRoi();
                coord = rect.getBounds();
                i1.show();

                i1.setProcessor(null, ip);

                int pix1 = 0;
                int i=0;
                int j=0;
                double mu=0;
                int cpt=0;

                int width = i1.getWidth();
                int height = i1.getHeight();

                byte[] pixels1 = (byte[]) ip.getPixels();
                byte[] pixels11 =new byte[pixels1.length];
                for (i = 0; i < pixels1.length; i++) pixels11[i]=pixels1[i];

                double[] pix_d1 = new double[width * height];
                double[][] matrix = new double[width][height];

                // pour mettre tous les pixels entre 0 et 255
                for (i = 0; i < pixels1.length; i++) {
                        pix1 = 0xff & pixels1[i];
                        pix_d1[i] = pix1;
                }

                for( i=0;i<width;i++)
                        for(j=0;j<height;j++)
                                matrix[i][j]=0;

                for( i=0;i<width;i++)
                        for( j=0;j<height;j++)
                                matrix[i][j]=pix_d1[i+j*width];

                for(i=coord.x;i<coord.x+coord.width;i++)
                        for(j=coord.y;j<coord.y+coord.height;j++){
                                mu+=matrix[i][j];
                                cpt++;
                        }

                        mu=mu/cpt;

                        jTextField6.setText(IJ.d2s(mu,3));

                        for (i = 0; i < pixels1.length; i++) pixels1[i]=pixels11[i];
                }
  }



